///////////////////////////////////////////////////////////
// Softwarebauelemente II, Aufgabe O3.1
//
// author:			Stephan Brumme
// last changes:	May 15, 2001

#if !defined(AFX_ROOM_H__34138CE0_E97C_11D4_9BB7_8BA1BD2C3421__INCLUDED_)
#define AFX_ROOM_H__34138CE0_E97C_11D4_9BB7_8BA1BD2C3421__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "BasicClass.h"


// declare class CRoom
class CRoom : public CBasicClass  
{
public:
	// constructors
    CRoom();
    CRoom(const CRoom& room);
	CRoom(int nNumberOfRoom, int nArea); 

	// return class name
	virtual string ClassnameOf() const { return "CRoom"; }

	// display the attributes
	virtual string Show() const;
	// only for internal purposes !
	virtual string ShowDebug() const;
	
	// validate a room
	virtual bool ClassInvariant() const;

    // copy constructors
	// non virtual
    CRoom&  operator = (const CRoom &room);
    // virtual
	virtual bool Copy(const CBasicClass* pClass);
	
	// compare two dates
	// non virtual
	bool operator == (const CRoom &room) const;
    // virtual
	virtual bool EqualValue(const CBasicClass* pClass) const;

	// access m_nNumberOfRoom
	int GetNumberOfRoom() const;
	void SetNumberOfRoom(const int nNumberOfRoom);
	
	// retrieve covered area
	int GetArea() const;

    enum { MAXNUMBER = 100, MAXAREA = 100 };

private:
	// hide the member variables
	int m_nNumberOfRoom;
	int m_nArea;
};

#endif // !defined(AFX_ROOM_H__34138CE0_E97C_11D4_9BB7_8BA1BD2C3421__INCLUDED_)
